import aiinterface.AIInterface;
import aiinterface.CommandCenter;
import enumerate.State;
import simulator.Simulator;
import struct.CharacterData;
import struct.FrameData;
import struct.GameData;
import struct.Key;

public class Machete implements AIInterface {

	private Key inputKey;
	private boolean playerNumber;
	private boolean oppNumber;
	private FrameData frameData;
	private CommandCenter cc;
	private Simulator simulator;
	private GameData gd;

	private int distance;
	private int energy;
	private CharacterData opp;
	private CharacterData my;

	private boolean isGameJustStarted;
	private int xDifference;

	@Override
	public int initialize(GameData gd, boolean playerNumber) {
		// TODO 自動生成されたメソッド・スタブ
		this.inputKey = new Key();
		this.playerNumber = playerNumber;
		if(playerNumber == true){
			this.oppNumber = false;
		}else{
			this.oppNumber = true;
		}
		this.frameData = new FrameData();
		this.cc = new CommandCenter();
		this.gd = gd;
		this.simulator = gd.getSimulator();
		this.isGameJustStarted = true;
		this.xDifference = -300;
		return 0;
	}

	@Override
	public void getInformation(FrameData fd, FrameData nonDelay) {
		// TODO 自動生成されたメソッド・スタブ
		this.frameData = fd;

	}

	@Override
	public void processing() {
		// TODO 自動生成されたメソッド・スタブ
		// TODO 自動生成されたメソッド・スタブ
				// First we check whether we are at the end of the round
						if(!frameData.getEmptyFlag() && frameData.getRemainingTime()>0){
							// Simulate the delay and look ahead 2 frames. The simulator class
							//exists already in FightingICE
							if (!isGameJustStarted)
								frameData = simulator.simulate(frameData, this.playerNumber, null, null, 17);
							else
								isGameJustStarted = false; //if the game just started, no point on simulating
							cc.setFrameData(frameData, playerNumber);
							distance = frameData.getDistanceX();
							energy = frameData.getCharacter(playerNumber).getEnergy();
							my = frameData.getCharacter(playerNumber);
							opp = frameData.getCharacter(oppNumber);
							xDifference = my.getCenterX() - opp.getCenterX();

							if (cc.getSkillFlag()) {
								// If there is a previous "command" still in execution,
								// then keep doing it
								inputKey = cc.getSkillKey();
							}
							else {
								// We empty the keys and cancel skill just in case
								inputKey.empty();
								cc.skillCancel();
								// Following is the brain of the reflex agent. It determines
								// distance to the enemy
								// and the energy of our agent and then it performs an action
								if ((opp.getEnergy() >= 300) && ((my.getHp() - opp.getHp()) <= 300))
									cc.commandCall("FOR_JUMP _B B B");
									// if the opp has 300 of energy, it is dangerous, so better jump!!
									// if the health difference is high we are dominating so we are fearless :)
								else if (!my.getState().equals(State.AIR) && !my.getState().equals(State.DOWN)) { //if not in air
									if ((distance > 150)) {
										cc.commandCall("FOR_JUMP"); //If its too far, then jump to get closer fast
									}
									else if (energy >= 300)
										cc.commandCall("STAND_D_DF_FC"); //High energy projectile
									else if ((distance > 100) && (energy >= 50))
										cc.commandCall("STAND_D_DB_BB"); //Perform a slide kick
									else if (opp.getState().equals(State.AIR)) //if enemy on Air
										cc.commandCall("STAND_F_D_DFA"); //Perform a big punch
									else if (distance > 100)
										cc.commandCall("6 6 6"); // Perform a quick dash to get closer
									else
										cc.commandCall("B"); //Perform a kick in all other cases, introduces randomness
								}
								else if ((distance <= 150) && (my.getState().equals(State.AIR) || my.getState().equals(State.DOWN))
										&& (((gd.getStageWidth() - my.getCenterX())>=200) || (xDifference > 0))
										&& ((my.getCenterX() >=200) || xDifference < 0)) { //Conditions to handle game corners
									if (energy >= 5)
										cc.commandCall("AIR_DB"); // Perform air down kick when in air
									else
										cc.commandCall("B"); //Perform a kick in all other cases, introduces randomness
								}
								else
									cc.commandCall("B"); //Perform a kick in all other cases, introduces randomness
							}
						}
						else isGameJustStarted = true;

	}

	@Override
	public Key input() {
		// TODO 自動生成されたメソッド・スタブ
		return this.inputKey;
	}

	@Override
	public void close() {
		// TODO 自動生成されたメソッド・スタブ

	}

	@Override
	public void roundEnd(int p1Hp, int p2Hp, int frames) {
		// TODO 自動生成されたメソッド・スタブ

	}

}
